/* Sachov centrum - Knihovna zahjen Petr Kuera 2000*/
/* Deklarace funkc potebnch pro pstup do souboru s knihovnou zahjen
 */

#ifndef __CTENI_H__
#define __CTENI_H__ 1

#include <stdio.h>
#include "datastr.h"
#include "cotyvar.h"

/*Promnn obsahujc odkaz na ten soubor s knihovnou zahjen*/
extern FILE *cteni_soubor;

/*Funkce inicializujc modul ten knihovny, nutno volat ped
  prvnm pouitm nkter ze zbylch funkc techo modulu.

  parametr jmsoub jmno souboru obsahujcho knihovnu zahjen
  vrac 0 pi spn inicializaci, jinak kd chyby dan konstantami
        v souboru obk_ch.h
 */
int init_cteni(char *jmsoub);

/*Funkce pete blok adrese ze souboru s knihovnou zahjen

  parametr blok_adr ukazuje na msto, kam se m uloit peten blok adrese
  parametr adresa obsahuje adresu tenho bloku v souboru vztaenou k aktulnmu
           obsahu konstanty ZAC_ADR deklarovan v souboru datastr.h. Adresa 0L vdy
           ukazuje na zkladn blok, z nj vedou odkazy dl.
  vrac 0 pi spnm ten, jinak kd chyby dan konstantami
        v souboru obk_ch.h
 */
int cti_blok_adresare(f_blok_adresare_t *blok_adr, long adresa);
/*Funkce pete blok s pozicemi ze souboru s knihovnou zahjen

  parametr blok ukazuje na msto, kam m bt peten blok uloen
  parametr adresa obsahuje adresu tenho bloku v souboru vztaenou
           k aktulnmu obsahu konstanty ZAC_POZIC deklarovan
           v souboru datastr.h.
  vrac 0 pi spnm ten, jinak kd chyby dan konstantami
        v souboru obk_ch.h
 */
int cti_blok_pozic(f_blok_pozic_t *blok, long adresa);
/*Funkce pete pozici ze souboru s knihovnou zahjen

  parametr blok ukazuje na msto, kam m bt peten pozice uloena
  parametr adresa obsahuje adresu ten pozice v souboru vztaenou
           k aktulnmu obsahu konstanty ZAC_POZIC deklarovan
           v souboru datastr.h. 
  vrac 0 pi spnm ten, jinak kd chyby dan konstantami
        v souboru obk_ch.h
 */
int cti_pozice(f_pozice_t *pozice, long adresa);
/*Nalezne pozici v souboru s knihovnou zahjen.

  parametr pozice obsahuje pozici, kter m bt nalezena v souboru
  parametr f_pozice ukazuje na msto, kam m bt uloena peten
           pozice
  vrac 0, nedojde-li k dn chyb a pozice je spn nalezena
        CH_CT_FAIL, nedojde-li k dn chyb, ale pozice nebyla nalezena
        kd chyby dan jinou konstantou deklarovanou v souboru obk_ch.h,
        dojde-li k jin chyb.
 */
int hledej_pozici(TPozice *pozice, f_pozice_t *f_pozice);

#endif
