/* achov centrum - Knihovna zahjen Petr Kuera 2000*/
/* Deklarace funkc potebnch pro pstup do knihovny zahjen na nejvy rovni
 */

#ifndef __KNIHOVNA_H__
#define __KNIHOVNA_H__ 1

#include "volby.h"
#include "cotyvar.h"

/*Ped pouitm knihovny nutno volat init_knihovna()

  parametr jmsoub uruje jmno souboru, v nm je obsaena peloen knihovna
  vrac 0 pi spn inicializaci, jinak kd chyby uren konstanatami
        v souboru obk_ch.h
 */
int init_knihovna(char *jmsoub);

/*Hled tah ze zadan pozice

  parametr pozice obsahuje pozici, z n je tah hledn
  parametr pole eco mus bt dlouh alespo 4, obsahuje pi nalezen tahu
           ECO pozice vznikl zahrnm tahu.
  vrac 0 pokud nebyla pozice nalezena, nebo dvoubajtov popis tahu, pokud byl tah nalezen.
        tah je vybrn nhodn s pravdpodobnost danou jeho vahou. V ppad nalezen tahu
        obsahuje pole eco ECO pozice vznikl zahrnm vrcenho tahu
*/
u16 query_knihovna(TPozice *pozice, char *eco);

/*
  Hled tah v knihovn zahjen

  parametr pozice obsahuje pozici, z n je tah hledn
  vrac 0 pokud nebyla pozice nalezena, nebo dvoubajtov popis tahu, pokud byl tah nalezen.
        tah je vybrn nhodn s pravdpodobnost danou jeho vahou.

  Poznmka: 0 nen kd dnho tahu.
*/
u16 KnihDejTah(TPozice *pozice);

#include "datastr.h"

/*
  Vrt vechny tahy, kter jsou v knihovn zahjen k dispozici pro danou pozici.

  parametr pozice obsahuje pozici, z n jsou tahy hledny
  parametr tahy po spnm hledn obsahuje ukazatel na pole s tahy,
           kter jsou k dispozici pro danou pozici. Pole je vytvoeno
           volnm malloc ve funkci v ppad, e je pozice v knihovn
           nalezena a e z n vede njak tah s nenulovou pravdpodobnost,
           v opanm ppad je vrceno msto pole NULL.
           Pokud je parametr tahy NULL, je vrcena hodnota CH_NULL
  parametr pocet_tahu obsahuje pi spnm nalezen pozice poet vrcench
           tah
  vrac 0 pokud nedojde k chyb (nenalezen pozice nen brno jako chyba,
          stejn jako neinicializovan knihovna v dob voln), jinak kd
          chyby dan konstantami v souboru obk_ch.h
 */
int knih_dej_vsechny_tahy(TPozice *pozice, f_tah_t **tahy, int *pocet_tahu);

#endif
